#include <iostream>
#include <cstring>
using namespace std;
#include <mpi.h>
using namespace MPI;

void greetings(const Intracomm& icomm)
{
    const int num  = icomm.Get_size();
    const int myid = icomm.Get_rank();
    int reslen;
    char *name  = new char [MAX_PROCESSOR_NAME],
         *chbuf = new char [MAX_PROCESSOR_NAME];

    Get_processor_name( name, reslen);

    if(myid==0)
    {
      cout << "   " << myid << " runs on " << name << endl;
      for(int i=1; i<num; ++i)
      {
         Status stat;

	 icomm.Recv(chbuf, MAX_PROCESSOR_NAME, CHAR, ANY_SOURCE, ANY_TAG, stat);

/*	icomm.Recv(chbuf, MAX_PROCESSOR_NAME, CHAR, i, ANY_TAG,stat);*/

        cout << "   " << stat.Get_source() << " runs on " << chbuf;
	cout << " (length: " << stat.Get_count(CHAR) << " )" << endl;
	//  stat.Get_error()	// Error code
      }
    }
    else
    {
        int dest = 0;
	icomm.Send(name, strlen(name)+1, CHAR,dest,myid);
    }
   delete [] chbuf; delete [] name;
}
