#include <iostream>
#include <cstring>
using namespace std;
#include <mpi.h>

void greetings(const MPI_Comm &icomm)
{
    int myid, numprocs;
    MPI_Comm_rank(icomm, &myid);                          // my MPI-rank
    MPI_Comm_size(icomm, &numprocs);
    int reslen;
    char *name  = new char [MPI_MAX_PROCESSOR_NAME],
         *chbuf = new char [MPI_MAX_PROCESSOR_NAME];

    MPI_Get_processor_name( name, &reslen);

    if (myid == 0) {
        cout << "   " << myid << " runs on " << name << endl;
        for (int i = 1; i < numprocs; ++i) {
            MPI_Status stat;
            stat.MPI_ERROR = 0;            // M U S T   be initialized!!

            MPI_Recv(chbuf, MPI_MAX_PROCESSOR_NAME, MPI_CHAR, MPI_ANY_SOURCE, MPI_ANY_TAG, icomm, &stat);

            //MPI_Recv(chbuf, MPI_MAX_PROCESSOR_NAME, MPI_CHAR, i, MPI_ANY_TAG, icomm, &stat);

            cout << "   " << stat.MPI_SOURCE << " runs on " << chbuf;
            int count;
            MPI_Get_count(&stat, MPI_CHAR, &count); // size of received data
            cout << " (length: " << count << " )" << endl;
            //  stat.Get_error()	// Error code
        }
    }
    else {
        int dest = 0;
        MPI_Send(name, strlen(name) + 1, MPI_CHAR, dest, myid, icomm);
    }
    delete [] chbuf;
    delete [] name;
}
