#include <cmath>
#include <cblas.h>               // cBLAS Library
#include <mpi.h>
using namespace std;
#include "mylib.h"


double scalar(const unsigned int N, const double x[], const double y[])
{
 double sum = 0.0;
 for (unsigned int i=0; i<N; ++i)
 {
    sum += x[i]*y[i];
 }
 return sum;
}



double par_scalar(const unsigned int N, const double x[], const double y[], const MPI::Intracomm& icomm)
{
  const double s = scalar(N,x,y);
        double sg;
  icomm.Allreduce(&s,&sg,1,MPI::DOUBLE,MPI::SUM);
  
  return(sg);

}
