#ifndef FILE_MYLIB
#define FILE_MYLIB
#include <offload.h> // to define _Offload_number_of_devices() and _Offload_get_device_number()



/** 	Performs dense matrix-vector product b := A*x
	@param b	resulting vector of dimension N
	@param A	NxM matrix
	@param M	#rows
	@param N	#columns
	@param x	vector to multiply with
*/
__attribute__ ((target(mic)))
void matmul(double b[], const double A[], const unsigned int M,
	    const unsigned int N, const double x[]);

__attribute__ ((target(mic)))
void matmul_blas(double b[], const double A[], const unsigned int M,
	    const unsigned int N, const double x[]);



#endif
