#ifndef FILE_MYLIB
#define FILE_MYLIB

/** 	Scalar product
	@param N	number of vector elements
	@param x	vector
	@param y	vector
	@return 	resulting Euclidian inner product <x,y>
*/
//#pragma omp declare target
double scalar(const unsigned int N, const double x[], const double y[]);
//#pragma omp end declare target
double scalar_p(const unsigned int N, const double x[], const double y[]);
double scalar_blas(const unsigned int N, const double x[], const double y[]);

/** 	Euclidian norm
	@param N	number of vector elements
	@param x	vector
	@return 	resulting Euclidian norm <x,y>
*/
double norm(const unsigned int N, const double x[]);





#endif
