# Basic Defintions for using INTEL compiler suite sequentially
# requires setting of COMPILER=PGI_

# Details for run time information
# export PGI_ACC_TIME=1
# unset PGI_ACC_TIME
# export PGI_ACC_NOTIFY=1
# export PGI_ACC_NOTIFY=3
# unset PGI_ACC_NOTIFY


# mephisto
# my sony
               ##  now:  export OPTIRUN = "optirun -v"

CC  = pgcc
CXX = pgc++
F77 = pgfortran
ifndef LINKER
  LINKER  = ${CC}
endif
LINKER  = ${CXX}


WARNINGS = -Minform=warn

#PGI_PROFILING += -Minfo=loop,vect,opt,intensity,mp,accel
PGI_PROFILING += -Minfo=accel -Mautoinline
# -Minfo
# -Mprof=lines
# -Minfo=accel,ccff
# -Mipa=inline

# http://stackoverflow.com/questions/9282461/icpc-c11-with-gcc-stdlib
CXXFLAGS +=  -e3 -fast -fastsse ${PGI_PROFILING} ${WARNINGS}
CFLAGS   +=  -e3 -fast -fastsse ${PGI_PROFILING} ${WARNINGS}
LINKFLAGS +=
#-lcblas
# PGI_PROFILING += -Mprof=lines -Minfo
#
#  for OpenACC
# Target architecture (nvidia,host)
#TA_ARCH = -DNDEBUG -ta=nvidia,host
#TA_ARCH = -acc -ta=host
#TA_ARCH = -acc -DNDEBUG -ta=nvidia:cc30,cuda5.5,keepgpu,fastmath,time
#TA_ARCH = -acc -DNDEBUG -ta=nvidia:cc30,cuda5.5,keepgpu,fastmath,time
TA_ARCH = -acc -DNDEBUG -ta=nvidia:cc2+,cuda5.5,fastmath,keepgpu
#,time
#-Mcuda=keepgpu,keepbin,keepptx,ptxinfo
# CFLAGS = -O3 -ta=$(TA_ARCH)

CXXFLAGS += -B -gopt $(TA_ARCH)
CFLAGS   += -B -gopt $(TA_ARCH)
#  -Minfo=al

# libcudart.a is needed for direct CUDA calls
LINKFLAGS  += -gopt $(TA_ARCH) -L${BINDIR}../lib $(PGI_PROFILING)
# -lcudart

default:	${PROGRAM}

${PROGRAM}:	${OBJECTS}
	$(LINKER)  $^  ${LINKFLAGS} -o $@

clean:
	rm -f ${PROGRAM} ${OBJECTS} *.gpu

clean_all:: clean
	@rm -f *_ *~ *.bak *.log *.out *.tar

run: clean ${PROGRAM}
	${OPTIRUN} ./${PROGRAM}

# tar the current directory
MY_DIR = `basename ${PWD}`
tar: clean_all
	@echo "Tar the directory: " ${MY_DIR}
	@cd .. ;\
	tar cf ${MY_DIR}.tar ${MY_DIR} *default.mk ;\
	cd ${MY_DIR}
# 	tar cf `basename ${PWD}`.tar *

doc:
	doxygen Doxyfile

#########################################################################

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $<

.c.o:
	$(CC) -c $(CFLAGS) $<

.f.o:
	$(F77) -c $(FFLAGS) $<

##################################################################################################
# #    some tools
# #  Simple run time profiling of your code
# #  CXXFLAGS += -g -pg -Minfo=ccff
# #  LINKFLAGS +=                       # no flag -pg


# Profiling options PGI, see: pgcollect -help
CPU_PROF = -allcache
GPU_PROF = -cuda=gmem,branch,cc2x -cudainit
#GPU_PROF = -cuda=branch:cc20
#
PROF_FILE = pgprof.out

prof: ${PROGRAM}
#	./$^
#	$(CUDA_HOME)/bin/nvvp &
#	export LD_LIBRARY_PATH=/state/partition1/apps/pgi/linux86-64/12.9/lib:$LD_LIBRARY_PATH
	${OPTIRUN} ${BINDIR}pgcollect $(GPU_PROF) ./$^
	${OPTIRUN} ${BINDIR}pgprof -exe ./$^  $(PROF_FILE) &


# Memory checker (slooooow!!!):
# see doc at /usr/local/cuda/doc/cuda-memcheck.pdf
# mem: ${PROGRAM}
# 	$(CUDA_HOME)memcheck ./$^
