/*
	Copy the accumulated diagonal of sk into d

	IN:	nx, ny	number of points in x/y-direction
		sk	matrix
		id	crs pointer of sk (points at last element in row)
	OUT:	d	diagonal of sk
*/
#include <iostream>
#include <mpi.h>
#include "vecaccu.h"
#include "debugd.h"
#include "getmatrix.h"


void AccuDiag(const int nnode, const int id[], const int ik[], const float sk[], float d[],
              const int nx, const int ny, const int neigh[], const int color, const MPI_Comm icomm)
{
   //int myrank;
   //MPI_Comm_rank(icomm,&myrank);
   //MPI_Barrier(icomm);fflush(stdout);MPI_Barrier(icomm);
   //std::cout << "Ich bin Nr. " << myrank << std::endl;
   //MPI_Barrier(icomm);fflush(stdout);MPI_Barrier(icomm);

    GetDiag(nnode, id, ik, sk, d);
    VecAccu(nx, ny, d, neigh, color, icomm);
    return;
}

