#include <iostream>
#include <cmath>
// #include <cblas.h>               // cBLAS Library
#include <mpi.h>
#include <omp.h>
using namespace std;
#include "mylib.h"


double scalar(const unsigned int N, const double x[], const double y[])
{
 double sum = 0.0;
#pragma omp parallel default(none) firstprivate(N) shared(cout, x,y, MPI::COMM_WORLD) reduction(+:sum)
{
 cout << "rank: " << MPI::COMM_WORLD.Get_rank() << "  thread " << omp_get_thread_num() << " out of " << omp_get_num_threads() << endl;
#pragma omp for schedule(static)
 for (unsigned int i=0; i<N; ++i)
 {
    sum += x[i]*y[i];
 }
}
 return sum;
}



double par_scalar(const unsigned int N, const double x[], const double y[], const MPI::Intracomm& icomm)
{
  const double s = scalar(N,x,y);
        double sg;
  icomm.Allreduce(&s,&sg,1,MPI::DOUBLE,MPI::SUM);

  return(sg);

}
