#include <cmath>
using namespace std;

#ifdef __INTEL_COMPILER 
  #pragma message(" ##########  Use of MKL  ###############")
  #include <mkl.h>                 // MKL
#else
  #pragma message(" ##########  Use of CBLAS  ###############")
extern "C"
{
  #include <cblas.h>               // cBLAS Library
}
#endif

#include "mylib.h"


void matmul(double b[], const double A[], const unsigned int M,
	    const unsigned int N, const double x[])
{
  for (unsigned int i=0; i<M; ++i)
  {
    double s(0.0);
    for (unsigned int j=0; j<N; ++j)
    {
      s += A[i*N+j] * x[j];
    }
    b[i] = s;
  }
}

void matmul_blas(double b[], const double A[], const unsigned int M,
	    const unsigned int N, const double x[])
{
  cblas_dgemv(CblasRowMajor,CblasNoTrans,M,N,1.0,A,N, x,1, 0.0,b,1);
//   cblas_dgemv(CblasColMajor,CblasTrans,M,N,1.0,A,N, x,1, 0.0,b,1);
}
