#ifndef FILE_MYLIB
#define FILE_MYLIB

/** 	Inner product
	@param[in] N	number of vector elements
	@param[in] x	vector
	@param[in] y	vector
	@return 	    resulting Euclidian inner product <x,y>
*/
double scalar(const unsigned int N, const double x[], const double y[]);
double scalar_p(const unsigned int N, const double x[], const double y[]);
double scalar_p2(const unsigned int N, const double x[], const double y[]);
double scalar_blas(const unsigned int N, const double x[], const double y[]);

/** 	L_2 Norm of a vector
	@param[in] N	number of vector elements
	@param[in] x	vector
	@return 	    resulting Euclidian norm <x,y>
*/
double norm(const unsigned int N, const double x[]);




#endif
