#include "vdop.h"

void vddiv(const int n,  double x[], const int ix,
                   const double y[], const int iy,
                   const double z[], const int iz)
{
   #pragma omp parallel for default(none) shared(x,y,z)
   for (int k=0; k<n; ++k)
   {
       x[k*ix] = y[k*iy]/z[k*iz];
   }
   return;
}

/******************************************************************************/

double dscapr(const int n, const double x[], const double y[])
{
   double    s = 0.0;

   #pragma omp parallel for default(none) shared(x,y) reduction(+:s)
   for (int k=0; k<n; ++k)
   {
       s += x[k]*y[k];
   }

   return s;
}
/******************************************************************************/

void vdaxpy(const int n, double x[], const double y[],
                   const double a,   const double z[] )
{
   #pragma omp parallel for default(none) shared(x,y,z)
   for (int k=0; k<n; ++k)
   {
       x[k] = y[k] + a*z[k];
   }
   return;
}
